﻿using System;
using System.IO;
using System.Web;
using System.Web.Caching;
using Stimulsoft.Report;
using Stimulsoft.Report.Web;

namespace WebApplication1
{
    public class StimulsoftViewerCacheHelper : StiCacheHelper
    {
        public override StiReport GetReport(string guid, StiServerCacheMode mode, TimeSpan timeout, CacheItemPriority priority)
        {
            var path = Path.Combine(HttpContext.Current.Server.MapPath("~/Temp"), "", $"StiViewerCache-{guid}");
            if (!File.Exists(path)) return null;
            var report = new StiReport();
            var packedReport = File.ReadAllText(path);
            if (guid.EndsWith("template")) report.LoadPackedReportFromString(packedReport);
            else report.LoadPackedDocumentFromString(packedReport);
            return report;
        }

        public override void SaveReport(StiReport report, string guid, StiServerCacheMode mode, TimeSpan timeout, CacheItemPriority priority)
        {
            
            var packedReport = guid.EndsWith("template") ? report.SavePackedReportToString() : report.SavePackedDocumentToString();
            var path = Path.Combine(HttpContext.Current.Server.MapPath("~/Temp"), "", $"StiViewerCache-{guid}");
            File.WriteAllText(path, packedReport);
        }

    }
}